package jtaDiscRack.presentation;

import jtaDiscRack.presentation.delements.*;
import jtaDiscRack.business.disc.DiscFactory;


/**
 * Used to manage collection of Disc DO data.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class Discs extends DCollection {

   private jtaDiscRack.business.person.Person myPerson;

   public Discs (jtaDiscRack.business.person.Person person) {
      super("Disc management");
      this.myPerson=person;
      fillCollection();
   }

   /**
     * Generates a new element of the class which instances
     * are members of collection of this class.
     *
     * return The generated instance of class that makes collection.
     */
   public DSimpleElement generateNewElement() {
      Disc d=null;
      try {
    	  jtaDiscRack.business.disc.Disc db=new jtaDiscRack.business.disc.Disc();
         db.setOwner(myPerson);
         d=new Disc(this,db);
         d.setRequired(true);
      } catch (Exception ex) {}
      return d;
   }

   private void fillCollection () {
      try {
    	  jtaDiscRack.business.disc.Disc[] discs=DiscFactory.findDiscsForPerson(myPerson);
         if (discs!=null && discs.length>0) {
            for (int i=0; i<discs.length; i++) {
               Disc d=new Disc(this,discs[i]);
               add(d);
            }
         }
      } catch (Exception ex) {}
   }

   public void onElementDeleted (DSimpleElement del) throws Exception {
      ((Disc)del).getMyDisc().delete();
   }

}

